{ Semestralni prace z PPA2 }

{ Mravenci }
{ Autori: Andrs David }
{         Smlsal Tomas }
{ verze 1.00.00 }

uses
  crt,
  m_simul, m_ants, m_antsc, m_area, m_dsktp, m_tvga,
  m_glob, m_menu, m_tools, m_soubor;

var
  i: integer;

procedure start;
{ spusti program }
const
  { moje paleta }
  my_palette: t_palette16 = ((R: 00; G: 00; B: 00),
                             (R: 02; G: 21; B: 12),
                             (R: 07; G: 26; B: 15),
                             (R: 14; G: 32; B: 19),
                             (R: 19; G: 38; B: 22),
                             (R: 25; G: 44; B: 25),
                             (R: 30; G: 49; B: 28),
                             (R: 48; G: 48; B: 48),
                             (R: 32; G: 32; B: 32),
                             (R: 22; G: 13; B: 05),
                             (R: 00; G: 00; B: 00),
                             (R: 00; G: 00; B: 00),
                             (R: 00; G: 00; B: 63),
                             (R: 00; G: 00; B: 00),
                             (R: 63; G: 63; B: 00),
                             (R: 63; G: 63; B: 63));

  my_palidx: array[0..16] of byte =
    (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 0);

  area_filename: string = '';
  ant_filename: string = '';

var
  ants: t_ant_ptr;
  area: t_area;

  old_palette: t_palette16;  { ulozeni puvodni palety }
  old_palidx: array[0..16] of byte; { ulozeni rozlozeni plaety }

  ant_way, area_way: t_create_way;
  ant_req: t_ant_req_ptr;

  ans, ans_vytvorit, ans_plochu, ans_mravence: byte;
  go_back, go_back2: boolean;

{  source_filename: string;}

  procedure animate_01;
  const
    x = 53;
  var
    cl_bar: string;
    i: byte;
  begin
    cl_bar:=replicate(' ', 30);
    for i:=36 to 44 do
    begin
      write_text(51, i, 7, 0, cl_bar);
      delay(50);
    end;

    for i:=45 downto 5 do
    begin
      write_text(x, i, 7, 0, 'Pocet');
      write_text(x, i+1, 7, 0, '  mravencu  :');
      write_text(x, i+2, 7, 0, '  vetvicek  :');

      write_text(x+14, i+1, 7, 0, w2s(ant_count, 3));
      write_text(x+14, i+2, 7, 0, w2s(wood_count, 3));
      write_text(51, i+3, 7, 0, cl_bar);
      delay(35);
    end;
  end;

  procedure draw_way;
  const
    x = 53;
    y = 39;
  begin
    write_text(x, y, 7, 0, 'Vytvorit');
    write_text(x+2, y+1, 7, 0, 'plochu   :');
    write_text(x+2, y+3, 7, 0, 'mravence :');

    write_text(x, y+6, 7, 0, 'Pocet');
    write_text(x+2, y+7, 7, 0, 'mravencu  :');
    write_text(x+2, y+8, 7, 0, 'vetvicek  :');

    write_text(x+14, y+7, 7, 0, w2s(ant_count, 3));
    write_text(x+14, y+8, 7, 0, w2s(wood_count, 3));

    case area_way of
      RAND:
      begin
        write_text(x+13, y+1, 7, 0, 'nahodne       ');
        write_text(x+02, y+2, 7, 0, '                         ');
      end;
      READ_FILE:
      begin
        write_text(x+13, y+1, 7, 0, 'ze souboru    ');
        write_text(x+02, y+2, 8, 0, write_path(area_filename, 25));
      end;
      FLAT:
      begin
        write_text(x+13, y+1, 7, 0, 'bez nerovnosti');
        write_text(x+02, y+2, 7, 0, '                         ');
      end;
      CUSTOM:
      begin
        write_text(x+13, y+1, 7, 0, 'dle pozadavku ');
        write_text(x+02, y+2, 7, 0, '                         ');
      end;
    end; { case }

    case ant_way of
      RAND:
      begin
        write_text(x+13, y+3, 7, 0, 'nahodne      ');
        write_text(x+02, y+4, 7, 0, '                         ');
      end;
      READ_FILE:
      begin
        write_text(x+13, y+3, 7, 0, 'ze souboru   ');
        write_text(x+02, y+4, 8, 0, write_path(ant_filename, 25));
      end;
      CUSTOM:
      begin
        write_text(x+13, y+3, 7, 0, 'dle pozadavku');
        write_text(x+02, y+4, 7, 0, '                         ');
      end;
    end; { case }
  end;

  procedure ask_count(question: string; min, max: word; var count: word);
  begin
    repeat
      count:=ask(question);
      if (count<min) or (count>max) then
      begin
        ask(' Neplatny rozsah !!!');
      end;
    until (count>=min) and (count<=max);
  end;

  function ask_for_filename(var name: string): boolean;
  var
    temp_name: string;
    ans_rewrite: byte;
  begin
    temp_name:=titulek('Jmeno souboru:');
    if temp_name='' then
    begin
      ask_for_filename:=FALSE;
    end else
        begin
          if over_nazev(temp_name) then
          begin
            if file_exist(temp_name) then
            begin
              name:=temp_name;
              ask_for_filename:=TRUE;
            end else
                begin
                  ask('Soubor neexistuje');
                  ask_for_filename:=FALSE;
                end;
          end else
              begin
                ask('Chybny nazev');
                ask_for_filename:=FALSE;
              end;
        end;
  end;

begin
  ants:=nil;

  randomize;

  init_desktop;

  get_palidx(old_palidx);
  get_palette(0, 255, old_palette);
  set_palidx(my_palidx);
  set_palette(0, 255, my_palette);

  cursor_off;
  set_blink(0);

  create_area(area, FLAT, 0, '');
{  draw_desktop;}
  write_text(56, 50, 15, 0, 'Mravenci (c) 1999');

  { nastav defaultni hodnoty }
  ant_way:=RAND;
  area_way:=RAND;
  ant_req:=nil;
  ant_count:=2;
  wood_count:=20;

  { menu }
  repeat
    draw_area(area);
    draw_way;

    dej_menu(menu_hlavni, ans);
    case ans of
      1: { start simulace }
      begin
        if init_simulation(ants, ant_count, ant_way, ant_req, ant_filename,
             area, wood_count, area_way, area_filename) then
        begin
          animate_01;
          start_simulation(ants, area);
          deinit_simulation(ants, area);
        end;
        { vymaz horni dil plochy }
        for i:=1 to 20 do
          write_text(51, i, 7, 0, '                             ');
      end;

      2: { vytvorit }
      begin
        go_back:=FALSE;
        repeat
          dej_menu(menu_vytvorit, ans_vytvorit);
          case ans_vytvorit of
            1: { plochu }
            begin
              go_back2:=FALSE;
              repeat
                dej_menu(menu_plochu, ans_plochu);
                case ans_plochu of
                  1:
                  begin
                    area_way:=RAND;
                    go_back2:=TRUE;
                  end;
                  2:
                  begin
                    if ask_for_filename(area_filename) then
                    begin
                      area_way:=READ_FILE;
                      go_back2:=TRUE;
                    end;
                  end;
                  31:
                  begin
                    area_way:=FLAT;
                    go_back2:=TRUE;
                  end;
                  4:
                  begin
                    ask_count('? Vloz pocet vetvicek:', 1, 100, wood_count);
                    draw_way;
                  end;
                  5:
                  begin
                    go_back2:=TRUE;
                  end;
                end; { case }
              until (go_back2);
              draw_way;
            end;
            2: { mravence }
            begin
              go_back2:=FALSE;
              repeat
                dej_menu(menu_mravence, ans_mravence);
                case ans_mravence of
                  1:
                  begin
                    ant_way:=RAND;
                    go_back2:=TRUE;
                  end;
                  2:
                  begin
                    if ask_for_filename(ant_filename) then
                    begin
                      ant_way:=READ_FILE;
                      go_back2:=TRUE;
                    end;
                  end;
                  3:
                  begin
                    ask_count('? Vloz pocet mravencu:', 1, 100, ant_count);
                    draw_way;
                  end;
                  4:
                  begin
                    go_back2:=TRUE;
                  end;
                end;
              until (go_back2);
              draw_way;
            end;
            3:
            begin
              go_back:=TRUE;
            end;
          end; { case }
        until go_back or (ans_vytvorit=0);
        go_back:=FALSE;
      end;

    end;
  until (ans=3);

  cursor_on;
  set_palidx(old_palidx);
  set_palette(0, 255, old_palette);
  set_blink(1);

  deinit_desktop;
end;

begin
  clrscr;
  writeln('memavail: ', memavail);
{  timer_running:=FALSE;}

  start;
(*
  writeln;
  writeln('memavail: ', memavail);
*)
end.
