{ modul pro praci s obrazovkou }
unit m_dsktp;

interface

procedure init_desktop;
{ prepne do modu 80x50 }
procedure deinit_desktop;
{ nastavi puvodni hodnoty obrazovky }
procedure draw_desktop;
{ nakresli plochu }
procedure draw_stat;
{ vypise statistiku }

procedure refresh_wood_carry;
{ napise na obrazovku pocet nesenych vetvicek }

implementation

uses
  crt, m_tools, m_tvga, m_glob;

var
  orig_mode: word; { obrazovkovy mod, ze ktereho byl program spusten }

procedure init_desktop;
{ prepne do modu 80x50 }
begin
  orig_mode:=lastmode;
  textmode(co80+font8x8);
end;

procedure deinit_desktop;
{ nastavi puvodni hodnoty obrazovky }
begin
  textmode(orig_mode);
end;

procedure draw_desktop;
{ nakresli plochu }
begin
  write_text(53, 5, 7, 0, 'Pocet');
  write_text(53, 6, 7, 0, '  mravencu  :' + i2s(ant_count, 3));
  write_text(53, 7, 7, 0, '  vetvicek  :' + i2s(wood_count, 3));

  draw_stat;
end;

procedure draw_stat;
{ vypise statistiku }
begin
  write_text(53, 8, 7, 0, '    nesenych: ' + i2s(wood_carry, 3));

  write_text(53, 12, 7, 0, 'Rychlost: ' + i2s(global_speed, 3));
end;

procedure refresh_wood_carry;
begin
  write_text(53+14, 8, 7, 0, i2s(wood_carry, 3));
end;

begin
end.