unit pole_ug;
interface

uses crt,graph; {pouziva i unitu graph a crt pro vykreslovani tahu}
const sx=3;{posunuti pole ve smeru osy x v CRT mode}
      sy=0;{posunuti pole ce smeru osy y v CRT mode}
      sp=11;{sirka pole}
      vp=11;{vyska pole}
      branky_X=[5..7];{rozsah branky v ose X}
      branky_Y=[1,vp];{rozsah branek v osach Y}

type Tpole=array[1..sp,1..vp] of byte;
{******************* verejen recepty nasi kucharky ***********************}
 procedure g_init; {inicializace grafiky}
 function test(px,py,smr:byte;ple:Tpole):boolean; {testuje byte v poli ple na X,Y na urcity smer}
 procedure plnuj(var ple:tpole); {generuje pole typu obdelnik 255}
 procedure pln(var ple:tpole); {generuje pole typu obdelnik}
 procedure prvek(px,py:byte;ple:tpole;grafika,podklad:boolean); {testuje prvek X,Y na smery kresli je}
 procedure vypis(ple:tpole;grafika,podklad:boolean);{vykresluje vsechny prvky pole a tim i cele hriste}
 function rotace(px,py,smr:byte;ple:tpole):byte;{vrati byte s pozadovanym smerem}
 procedure set_bite(px,py,smr:byte; var ple:tpole); {v poli ple nastavy bytu na X,Y bite - smer}
 function odraz(px,py,smr:byte;ple:tpole):boolean; {testuje zda doslo k odrazu}
 procedure add_smer(var x,y,sm:byte;var ple:tpole;grafika:boolean);{nastavi bite pro prislusna byte}
 function chk_smer(px,py,smr:byte;ple:tpole):boolean; {overuje platnost dalsiho tahu v hristi}
 function kudy:byte; {vraci dalsi tah}

 {************************* soukroma  implementace ************}

implementation

 procedure g_init; {inicializace grafiky}
 var
  Gd, Gm: Integer;
  Radius: Integer;
 		{To snad kazdy zna}
 begin
  Gd := Detect;
  InitGraph(Gd, Gm, 'c:\bp\bgi');
 end;

 function test(px,py,smr:byte;ple:Tpole):boolean; {testuje BYte urceny X,Y v poli ple na dany smer}
 var i,p:byte;

 begin
   if (px>sp)or(px<1)or(py>vp)or(py<1) then p:=255 {ohraniceni}
   else p:=ple[px,py]; {jinak se testnovany prvek nastavi na pozadovany byte v ple na X,Y}
   asm {asemblerovska cast zajistujici samotnou funkci}
   mov al,p {dej do AL testovany prvek}
   mov bl,smr {dej do BL pozadovany smer}
   sub bl,1 {zmensi ho o jedna - to kvuli cyklu aby bylo mozne ho preskocit}
   cmp bl,0 {porovnej s nulou}
   jz @konec {pokud je nula tak uz jsme skoncily}
  @cykl: {samotny cyklus presouvani pozadovaneho smeru vzdy o jednu do prava}
   shr al,1 {posun testovany o jednu do prava}
   sub bl,1 {zmesni pocet opakovani posuvu}
   cmp bl,0 {porovnej s nulou}
   jnz @cykl {pokud neni nula tak jeste neni konec opakovani a tak sup na cykl}
  @konec: {sem skocit pro konci opakovani tzn smer v testovanem prvku je na prvni pozici}
   and al,0001b {zbav se dalsich nepotrebnych prvku na levo od pozadovaneho smeru}
   mov p,al {vrat AL do pomocneho p}
   end;
  if p=1 then test:=true else test:=false; {pokud je p = 1 tzn pozadovany smer existuje jinak false}
 end;


 Procedure plnuj(var ple:tpole); {generuje pole obdelnikoveho typu - podklad -----}
  var i,j:byte; {pomocne souradnice}

  begin
   for i:= 1 to vp do {do vysky pole}
    begin
    for j:= 1 to sp do {do sirky pole}
     begin
       ple[j,i]:=255; {vzdy vynuluj}
     end;
   end;
  end; {--------------------------------------------------------------------------}

 Procedure pln(var ple:tpole); {generuje pole obdelnikoveho typu}
  var i,j:byte; {pomocne souradnice}

  begin
   for i:= 1 to vp do {do vysky pole}
    begin
    for j:= 1 to sp do {do sirky pole}
     begin
       ple[j,i]:=0; {vzdy vynuluj}
       if i=1 then ple[j,i]:= 227; {nastavovani hrani hriste ******************}
       if i=vp then ple[j,i]:=62;
       if j=1 then ple[j,i]:=248;
       if j=sp then ple[j,i]:=143; {*******************************************}
       if (i in branky_y)and(j in branky_x) then ple[j,i]:=0; {prepsani branek}
     end;
   end;
   ple[1,1]:=251; {nastaveni rohu hriste ++++++++++++++++++++++++++++++++++++++}
   ple[1,vp]:=254;
   ple[sp,1]:=239;
   ple[sp,vp]:=191;{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  end;

procedure gsmery(px,py,smer:byte;ple:tpole;podklad:boolean); {vykresluje smery v grafice}
 var gx,gy,pbp,pbpo:integer; {podle vstupnich parametru px ,py vykresli dany smer}
 begin
  pbp:=getcolor;
  pbpo:=getbkcolor;
  if podklad then setcolor(8);
  case smer of {podle smeru ktery chceme vykreslit}
   1: begin {pouze nudne nastavovani souradnic a vykreslovani line a zpetneho efektu ////////////}
        gx:=10*(2*(px+1)+sx)-4;
        gy:=10*(2*(py+1)-3)+13;
        if test(px+1,py,7,ple) then line(gx,gy-15,gx+14,gy-1);
        line(gx,gy,gx+15,gy-15);
      end;
   2: begin
        gx:=10*(2*(px+1)+sx)-3;
        gy:=10*(2*(py+1)-2)+5;
        line(gx,gy,gx+13,gy);
      end;
   3: begin
        gx:=10*(2*(px+1)+sx)-4;
        gy:=10*(2*(py+1)-1);
        if test(px+1,py,5,ple) then line(gx,gy+13,gx+15,gy-2);
        line(gx,gy-2,gx+15,gy+13);
      end;
   4: begin
        gx:=3+10*(2*(px+1)+sx-1);
        gy:=10*(2*(py+1)-1);
        line(gx,gy,gx,gy+10);
      end;
   5: begin
        gx:=10*(2*(px+1)-2+sx)-4;
        gy:=10*(2*(py+1))+3;
        if test(px-1,py,3,ple) then line(gx,gy-15,gx+15,gy);
        line(gx,gy,gx+15,gy-15);
      end;
   6: begin
        gx:=10*(2*(px+1)-2+sx)-3;
        gy:=10*(2*(py+1)-2)+5;
        line(gx,gy,gx+13,gy);
      end;
   7: begin
        gx:=10*(2*(px+1)-2+sx)-3;
        gy:=10*(2*(py+1)-3)+1;
        if test(px-1,py,1,ple) then line(gx-1,gy+12,gx+13,gy-2);
        line(gx,gy-2,gx+14,gy+12);
      end;
   8: begin
        gx:=3+10*(2*(px+1)-1+sx);
        gy:=10*(2*(py+1)-3);
        line(gx,gy+10,gx,gy);
      end; {///////////////////////////////////////////////////////////////////////////////////}
   9: begin {vykresluje neobsazene body v hristi ++++++++++++++++++++++++++++++++++++++++++++++}
        if podklad then
        begin
         gx:=10*(2*(px+1)+sx-1);
         gy:=10*(2*(py+1)-2);
         outtextxy(gx,gy,'.');
        end;
      end;{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
   end;
   setcolor(pbp);
 end;


procedure smery(px,py,smer:byte;ple:tpole;podklad:boolean); {dtto jako vyse akorat v CRT mode -----------------}

 begin
  if podklad then textcolor(8);
  case smer of
   1: begin
        gotoxy(2*(px+1)+sx,2*(py+1)-3);
        if test(px+1,py,7,ple) then write('X')
        else  write('/');
      end;
   2: begin
        gotoxy(2*(px+1)+sx,2*(py+1)-2);
        write('_');
      end;
   3: begin
        gotoxy(2*(px+1)+sx,2*(py+1)-1);
        if test(px+1,py,5,ple) then write('X')
        else write('\');
      end;
   4: begin
        gotoxy(2*(px+1)-1+sx,2*(py+1)-1);
        write('I');
      end;
   5: begin
        gotoxy(2*(px+1)-2+sx,2*(py+1)-1);
        if test(px-1,py,3,ple) then write('X')
        else write('/');
      end;
   6: begin
        gotoxy(2*(px+1)-2+sx,2*(py+1)-2);
        write('_');
      end;
   7: begin
        gotoxy(2*(px+1)-2+sx,2*(py+1)-3);
        if test(px-1,py,1,ple) then write('X')
        else write('\');
      end;
   8: begin
        gotoxy(2*(px+1)-1+sx,2*(py+1)-3);
        write('I');
      end;
   9: begin
       if podklad then
        begin
         gotoxy(2*(px+1)+sx-1,2*(py+1)-2);
         write('.');
       end;
      end;{---------------------------------------------------------------------------------}
   end;
  textcolor(7);
 end;

 procedure prvek(px,py:byte;ple:tpole;grafika,podklad:boolean); {testuje prvek X,Y na smery kresli je}
  var i:byte;

 begin
  for i:= 1 to 8 do {smeru je celkem osm}
   begin
    if test(px,py,i,ple) then if grafika then gsmery(px,py,i,ple,podklad) {jestli je smer a grafika}
     else smery(px,py,i,ple,podklad); 					  {jinak jestli je smer a CRT}
   end;
   if grafika then gsmery(px,py,9,ple,podklad) {pokud je grafika}
    else smery(px,py,9,ple,podklad); {CRT - stra se o vykresleni smeru 9=bod -mozna predelano na mic later}
 end;

 procedure vypis(ple:tpole;grafika,podklad:boolean);{vykresluje vsechny prvky pole a tim i cele hriste}
 var i,j:byte;

 begin
  for i:=1 to vp do {do vysky pole}
   begin
    for j:=1 to sp do {do sirky pole }
     begin
      prvek(j,i,ple,grafika,podklad); {vykresli pozadovany prvek}
     end;
   end;
 end;

function rotace(px,py,smr:byte;ple:tpole):byte;  {vrati byte s pozadovanym smerem}
var s,p,i:byte;   				{vyuziva se pro nastavovani prvku}
 begin
   s:=smr; {pozadovany smer, kupodivu mi asembler nebral <smr>}
   p:=1; {je prvni smer}
   if not test(px,py,smr,ple) then {pokud uz neni}
   begin
   asm {zanam asm cast pro nastaveni p na pozadovany smer .... detajlneji popsano vyse ///////////}
    mov al,p
    mov bl,s
    sub bl,1
    cmp bl,0
    jz @konec
   @cykl:
    shl al,1
    sub bl,1
    cmp bl,0
    jnz @cykl
   @konec:
    mov p,al {////////////////////////////////////////////////////////////////////////////////////}
   end;
    rotace:=p; {rotace je p}
   end
   else   rotace:=0; {jinak neni rotace}
 end;

procedure set_bite(px,py,smr:byte; var ple:tpole); {Byte ma X,Y v PLe priradi urceny smer}
 var p:byte;
 begin
 p:=rotace(px,py,smr,ple); {nastaveni p pomoci rotace na pozadovany smer}
 ple[px,py]:=ple[px,py]+p; {pricteni k prvku ple +p zajisti obsazeni smeru}
 end;

function odraz(px,py,smr:byte;ple:tpole):boolean; {testuje moznost odrazu}
 var sm,p:byte;
 begin
  if smr>4 then sm:=smr-4 else sm:=smr+4; {toto je osetreni na nezadouci smer}
   asm {asm cast na nastaveni smeru do p +++++++++++++++++++++++++++++++++++++++++++++++++}
     mov al,1
     mov bl,sm
     sub bl,1
     cmp bl,0
     jz @konec
    @cykl:
     shl al,1
     sub bl,1    {slo pouzit funkce rotace a to jsem zjistil az pri psani dokumentace}
     cmp bl,0
     jnz @cykl
    @konec:
     mov p,al
   end;{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
   if ple[px,py]>p then {pokud je prvek ple na X,Y ruzny od zpetneho smeru tak odraz=OK}
   odraz:=true
   else odraz:=false; {jinak false}
 end;


procedure add_smer(var x,y,sm:byte;var ple:tpole;grafika:boolean); {prida smer a vykresli tah}

 begin
  set_bite(x,y,sm,ple); {prida smer vykopavanemu prvku}
  prvek(X,Y,ple,grafika,false); {vykresli jej}
  gotoxy(2*(x+1)+sx-1,2*(y+1)-2); {trapne vykresleni .}
  write('.');
  gotoxy(40,1); {hlaska o provadenem tahu}
  write('Smer: ',sm,' X:',x,' Y:',y);
  case sm of {podle smeru se nastavuje novy prvke v ple a rovnou se nastavuje prichozi smer }
   1:begin {********************************************************************************}
      inc(x);
      dec(y);
      set_bite(x,y,5,ple);
     end;
   2:begin
      inc(x);
      set_bite(x,y,6,ple);
     end;
   3:begin
      inc(x);
      inc(y);
      set_bite(x,y,7,ple);
     end;
   4:begin
      inc(y);
      set_bite(x,y,8,ple);
     end;
   5:begin
      dec(x);
      inc(y);
      set_bite(x,y,1,ple);
     end;
   6:begin
      dec(x);
      set_bite(x,y,2,ple);
     end;
   7:begin
      dec(x);
      dec(y);
      set_bite(x,y,3,ple);
     end;
   8:begin
      dec(y);
      set_bite(x,y,4,ple);
     end;
   end; {****************************************************************************************}
   write(' na X:',X,' a Y:',y);{trapna hlaska}
  end;

function chk_smer(px,py,smr:byte;ple:tpole):boolean; {zajistuje testovani pozadovaneho tahu}
 var xx,yy:byte; {pro umely pred tah a zjisteni moznosti tahu}
     result:boolean;

 begin
  result:=true; {predpoklad ze je mozno}
  xx:=px; {pomocne souradnice - virtualni}
  yy:=py; {pomocne souradnice - virtualni}
  case smr of {podle pozadovaneho smeru proved simulaci a vyhodnot result ---------------------}
  1:begin
     inc(xx);
     dec(yy);
     if test(xx,yy,5,ple) then result:=false;
    end;
  2:begin
     inc(xx);
     if test(xx,yy,6,ple) then result:=false;
    end;
  3:begin
     inc(xx);
     inc(yy);
     if test(xx,yy,7,ple) then result:=false;
    end;
  4:begin
     inc(yy);
     if test(xx,yy,8,ple) then result:=false;
    end;
  5:begin
     dec(xx);
     inc(yy);
     if test(xx,yy,1,ple) then result:=false;
    end;
  6:begin
     dec(xx);
     if test(xx,yy,2,ple) then result:=false;
    end;
  7:begin
     dec(xx);
     dec(yy);
     if test(xx,yy,3,ple) then result:=false;
    end;
  8:begin
     dec(yy);
     if test(xx,yy,4,ple) then result:=false;
    end;
  end; {--------------------------------------------------------------------------------------}
  chk_smer:=result; {nastaveni funkce}
 end;

function kudy:byte; {pro ovladani klavesnice a vraci dalsi smer tahu}
var a:char; {pomocna klavesa}
    p:byte; {pomocna promena}
begin
 p:=0; {zatim nikam netahneme, ikdyz ......... {poznamka autora}
 while p =0 do {a dokud nikam netahneme}
 begin
  a:=readkey; 
  case a of   {ano ovladame pomoci klaves 1-9 mimo 5 ////////////////////////////////////////}
     #49:p:=5;
     #50:p:=4;
     #51:p:=3;
     #52:p:=6;
     #54:p:=2;
     #55:p:=7;
     #56:p:=8;
     #57:p:=1;
  end;
 end;{///////////////////////////////////////////////////////////////////////////////////////}
 kudy:=p; {uz jsme tahli}
end;

begin {zadne nastaveni}
end.