Unit F_GRAFIK;
Interface
uses graph,f_typy;
procedure MakeZacatek(dx,dy:integer;BVlastni,BSoupere:PBrana);
procedure Bod(x,y:integer;Red:boolean);
procedure Cara(x,y,Tah:integer);
procedure KonecGrafiky;

Implementation
uses F_SYSTEM;{kvuli LZE}
var
 koef:integer;
{**********************}
procedure MakeZacatek;
var
 i,grDriver,grMode:integer;
begin
 grDriver:=Detect;
 InitGraph(grDriver,grMode,'c:\programs\tp7\bgi');  {cesta k egavga.bgi}
 koef:=(GetMaxX div 2) div dx;
 SetColor(7);
 Bar(30,30,(dx-1)*koef+30,(dy-1)*koef+30);
 SetColor(0);
 for i:=1 to dx-1 do
  Line(koef*i+30,30,koef*i+30,(dy-1)*koef+30);
 for i:=1 to dy-1 do
  Line(30,koef*i+30,(dx-1)*koef+30,koef*i+30);
 SetColor(7);
 Rectangle(30,30,(dx-1)*koef+30,(dy-1)*koef+30);
 SetColor(4);
 SetLineStyle(0,0,ThickWidth);
 repeat
  Line((BVlastni^.x-1)*koef+30,(BVlastni^.y-1)*koef+30,(BVlastni^.dalsi^.x-1)*koef+30,(BVlastni^.dalsi^.y-1)*koef+30);
  BVlastni:=BVlastni^.dalsi;
 until BVlastni^.dalsi=nil;
 SetColor(1);
 SetLineStyle(0,0,ThickWidth);
 repeat
  Line((BSoupere^.x-1)*koef+30,(BSoupere^.y-1)*koef+30,(BSoupere^.dalsi^.x-1)*koef+30,(BSoupere^.dalsi^.y-1)*koef+30);
  BSoupere:=BSoupere^.dalsi;
 until BSoupere^.dalsi=nil;
end;
{************************}
procedure Bod;
begin
 if Red then SetColor(4)
        else SetColor(1);
 Circle(koef*(x-1)+30,koef*(y-1)+30,1);
end;
{*************************}
procedure Cara;
var
 x2,y2:integer;
begin
 case Tah of
  1:  begin x2:=x-1; y2:=y; end;
  2:  begin x2:=x-1; y2:=y+1; end;
  4:  begin y2:=y+1; x2:=x; end;
  8:  begin x2:=x+1; y2:=y+1; end;
  16: begin x2:=x+1; y2:=y; end;
  32: begin x2:=x+1; y2:=y-1; end;
  64: begin y2:=y-1; x2:=x; end;
  128:begin x2:=x-1; y2:=y-1; end;
 end;
 SetColor(0);
 Circle(koef*(x2-1)+30,koef*(y2-1)+30,1);
 Line(koef*(x-1)+30,koef*(y-1)+30,koef*(x2-1)+30,koef*(y2-1)+30);
end;
{***********************}
procedure KonecGrafiky;
begin
 CloseGraph;
end;
end.