Unit F_R6Tah;
Interface
uses f_typy;
function R6Tah(H:PPole;dx,dy,x,y:integer;BVlastni,BSoupere:PBrana;Cas:LongInt):integer;

Implementation
uses f_system;
Type
    Ukstr=^Strom;
    Strom=record
                T1  :Ukstr;
                T2  :Ukstr;
                T4  :Ukstr;
                T8  :Ukstr;
                T16 :Ukstr;
                T32 :Ukstr;
                T64 :Ukstr;
                T128:Ukstr;
                X,Y:Integer;
                Koef:Real;
                Rodic:Ukstr;
                Krok:Byte;
                Tah:Integer;
                end;
Var
   Uktree,Nejlepsi,Zacatek,Rodic:Ukstr;
   Clock:LongInt absolute 0:$046c;
   PrumerX,PrumerY,SouX,SouY:Real;

{.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.}
function Podminky(H:PPole;BV,BS:PBrana;dx,dy,x,y:integer;var Tah:integer):boolean;
var
 Hriste:^Byte;
 BVHead,BSHead:PBrana;
begin
 Hriste:=H;
 Tah:=0;
 Podminky:=true;
 if (dx<7)or(dy<9) then Tah:=-4;
 if H=nil then Tah:=-5;
 {BVHead:=BV;
 BSHead:=BS;
 repeat
  if BV=nil then Tah:=-8;
  BV:=BV^.dalsi;
 until BV=BVHead;
 repeat
  if BV=nil then Tah:=-8;
  BV:=BV^.predchozi;
 until BV=BVHead;
 repeat
  if BS=nil then Tah:=-9;
  BV:=BS^.dalsi;
 until BS=BSHead;
 repeat
  if BV=nil then Tah:=-9;
  BS:=BS^.predchozi;
 until BS=BVHead;       }
 if BV=nil then Tah:=-6;
 if BS=nil then Tah:=-7;
 Integer(Hriste):=(y-1)*dx+x;
 if Hriste^=255 then Tah:=-10;
 if Tah<>0 then Podminky:=false;
end;
{**************************************}
Procedure SourBran(var PrumX,PrumY:Real;Brana:PBrana);
Var
 adr:PBrana;
 n:Byte;
begin
 adr:=Brana;
 n:=0;
 PrumX:=0;
 PrumY:=0;
 repeat
   PrumX:=PrumX+adr^.X;
   PrumY:=PrumY+adr^.Y;
   n:=n+1;
   adr:=adr^.dalsi;
 until adr=nil;
 PrumX:=PrumX/n;
 PrumY:=PrumY/n;
end;
{***---***---***---***---***---***}
Procedure Porovnej(Zacatek:Ukstr;Var Best:Ukstr);
begin
     If Best<>nil then
     begin
       If Zacatek^.Koef<Best^.Koef Then Best:=Zacatek;
       If (Zacatek^.Koef=Best^.Koef)and
          (Zacatek^.Krok>Best^.Krok)Then Best:=Zacatek;
     end
     else Best:=Zacatek;
end;
{/*/*--/*/*--/*/*--/*/*--/*/*--/*/*--/*/*--/*/*--/*/*}
Function Odraz(Hriste:PPole;sx,sy,dx:Integer):boolean;
Var PocetTahu:Shortint;
    i,n,obsazeno:Byte;
    H:^Byte;
begin
  Odraz:=false;
  H:=Hriste;
  Integer(H):=(sy-1)*dx+sx;
  Obsazeno:=H^;
  PocetTahu:=0;
  n:=128;
  For i:=1 to 8 Do
  begin
    If (Obsazeno div n)>0 Then PocetTahu:=PocetTahu+1;
    Obsazeno:=Obsazeno mod n;
    n:=n div 2;
  end;
  If (PocetTahu>0) and (PocetTahu<7) Then
  {If Obsazeno>0 Then} Odraz:=True;{end;}
end;
{-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-}
Function JeBrana(x,y:integer;Brana:PBrana):boolean;
begin
 JeBrana:=false;
 repeat
  if (Brana^.x=x)and(Brana^.y=y) then JeBrana:=true;
  Brana:=Brana^.dalsi;
 until Brana=nil;
end;
{/8*/8*/8*/8*/8*/8*/8*/8*/8*/8*/8*/8}
Function Zablokovani(x,y,dx:Integer;H:PPole):boolean;
Var
   Obsazeno,PocTah,i,n:Byte;
   Hriste:^Byte;
begin
  Hriste:=H;
  Integer(Hriste):=(y-1)*dx+x;
  Obsazeno:=Hriste^;
  PocTah:=0;
  n:=128;
  For i:=1 to 8 Do
  begin
    If (Obsazeno div n)>0 Then PocTah:=PocTah+1;
    Obsazeno:=Obsazeno mod n;
    n:=n div 2;
  end;
  If (PocTah>=7) Then Zablokovani:=True else Zablokovani:=false;
end;
{[[]]--[[]]--[[]]--[[]]--[[]]--[[]]--[[]]--[[]]--[[]]--[[]]--[[]]}
Procedure DelejStrom(Zacatek,Rodic:Ukstr;sx,sy,dx:Integer;Hriste:PPole;BVlastni,BSoupere:PBrana;T:Integer);
Var
   i:Byte;
   tah:integer;
   x,y:Integer;
   koef:Real;
   k:Real;
   B:Boolean;
begin
  tah:=1;
  x:=sx;
  y:=sy;
  Zacatek^.T1:=nil;
  Zacatek^.T2:=nil;
  Zacatek^.T4:=nil;
  Zacatek^.T8:=nil;
  Zacatek^.T16:=nil;
  Zacatek^.T32:=nil;
  Zacatek^.T64:=nil;
  Zacatek^.T128:=nil;
  Zacatek^.x:=sx;
  Zacatek^.y:=sy;
    K:=sqr(PrumerX-sx)+sqr(sy-PrumerY){-sqr(SouX-sx)-sqr(SouY-sy)};
    If Zablokovani(x,y,dx,Hriste) Then K:=1.7e38;
  Zacatek^.Koef:=K;
  Zacatek^.Rodic:=Rodic;
  Zacatek^.Tah:=T;

  If rodic<>nil then Zacatek^.Krok:=Rodic^.Krok+1 else Zacatek^.Krok:=0;
  If (Zacatek^.Krok>0) and Odraz(Hriste,sx,sy,dx) and
     Odraz(Hriste,Rodic^.x,Rodic^.y,dx) and not Zablokovani(sx,sy,dx,Hriste)
     and not JeBrana(sx,sy,BVlastni)
  Then b:=True else b:=False;

  If (Zacatek^.Krok<1)or(B and (Zacatek^.Krok<4)) then
    begin
    For i:=1 to 8 do
    begin
    If Lze(Hriste,dx,Tah,sx,sy)and
     ( ((Zacatek^.Tah=1)and(Tah<>16))or
       ((Zacatek^.Tah=2)and(Tah<>32))or
       ((Zacatek^.Tah=4)and(Tah<>64))or
       ((Zacatek^.Tah=8)and(Tah<>128))or
       ((Zacatek^.Tah=16)and(Tah<>1))or
       ((Zacatek^.Tah=32)and(Tah<>2))or
       ((Zacatek^.Tah=64)and(Tah<>4))or
       ((Zacatek^.Tah=128)and(Tah<>8))or
       (Zacatek^.Krok=0))   then
    begin
      Case Tah of
      1: begin
          x:=sx+1;
          y:=sy;
          New(Zacatek^.T1);
          DelejStrom(Zacatek^.T1,Zacatek,x,y,dx,Hriste,BVlastni,BSoupere,Tah);
         end;
      2: begin
          x:=sx+1;
          y:=sy-1;
          New(Zacatek^.T2);
          DelejStrom(Zacatek^.T2,Zacatek,x,y,dx,Hriste,BVlastni,BSoupere,Tah);
         end;
      4: begin
          x:=sx;
          y:=sy-1;
          New(Zacatek^.T4);
          DelejStrom(Zacatek^.T4,Zacatek,x,y,dx,Hriste,BVlastni,BSoupere,Tah);
         end;
      8: begin
          x:=sx-1;
          y:=sy-1;
          New(Zacatek^.T8);
          DelejStrom(Zacatek^.T8,Zacatek,x,y,dx,Hriste,BVlastni,BSoupere,Tah);
         end;
     16: begin
          x:=sx-1;
          y:=sy;
          New(Zacatek^.T16);
          DelejStrom(Zacatek^.T16,Zacatek,x,y,dx,Hriste,BVlastni,BSoupere,Tah);
         end;
     32: begin
          x:=sx-1;
          y:=sy+1;
          New(Zacatek^.T32);
          DelejStrom(Zacatek^.T32,Zacatek,x,y,dx,Hriste,BVlastni,BSoupere,Tah);
         end;
     64: begin
          x:=sx;
          y:=sy+1;
          New(Zacatek^.T64);
          DelejStrom(Zacatek^.T64,Zacatek,x,y,dx,Hriste,BVlastni,BSoupere,Tah);
         end;
    128: begin
          x:=sx+1;
          y:=sy+1;
          New(Zacatek^.T128);
          DelejStrom(Zacatek^.T128,Zacatek,x,y,dx,Hriste,BVlastni,BSoupere,Tah);
         end;
     end;{case}
     end;{if}
     Tah:=Tah*2;
     end;{for}
     end{if}
     else Porovnej(Zacatek,Nejlepsi);
end;{Procedure}
{/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/}
Function Najdi(Nejlepsi:Ukstr):Integer;
begin
  If nejlepsi=nil then najdi:=-10 else
  begin
    While Nejlepsi^.rodic^.rodic<>nil do
    begin
        Nejlepsi:=Nejlepsi^.Rodic;
    end;
    Najdi:=Nejlepsi^.Tah;
  end;
end;
{-*/-*/-*/-*/-*/-*/-*/-*/-*/-*/-*/-*/}
Procedure Maz(Zacatek:Ukstr);
begin
     If Zacatek^.Rodic<>nil then
     Case Zacatek^.Tah of
         1: Zacatek^.Rodic^.T1:=nil;
         2: Zacatek^.Rodic^.T2:=nil;
         4: Zacatek^.Rodic^.T4:=nil;
         8: Zacatek^.Rodic^.T8:=nil;
        16: Zacatek^.Rodic^.T16:=nil;
        32: Zacatek^.Rodic^.T32:=nil;
        64: Zacatek^.Rodic^.T64:=nil;
       128: Zacatek^.Rodic^.T128:=nil;
     end;
     Dispose(Zacatek);
end;

{*/*/*----*/*/*----*/*/*---}
Procedure MazStrom(Zacatek:Ukstr);
Var i:Byte;
    Tah:integer;
begin
    begin
      tah:=1;
      For i:=1 to 8 do
      begin
      Case Tah of
          1: If (zacatek^.T1<>nil) then MazStrom(Zacatek^.T1);
          2: If (zacatek^.T2<>nil) then MazStrom(Zacatek^.T2);
          4: If (zacatek^.T4<>nil) then MazStrom(Zacatek^.T4);
          8: If (zacatek^.T8<>nil) then MazStrom(Zacatek^.T8);
         16: If (zacatek^.T16<>nil) then MazStrom(Zacatek^.T16);
         32: If (zacatek^.T32<>nil) then MazStrom(Zacatek^.T32);
         64: If (zacatek^.T64<>nil) then MazStrom(Zacatek^.T64);
        128: If (zacatek^.T128<>nil) then MazStrom(Zacatek^.T128);
      end; {case}
      Tah:=Tah*2;
     end;{for}
     end;{else}
     Maz(Zacatek);
end;{Procedure}


Function R6Tah(H:PPole;dx,dy,x,y:integer;BVlastni,BSoupere:PBrana;Cas:LongInt):integer;
var
 Hriste:^byte;
 Stred:real;
 i,T:integer;
 Time,Start:LongInt;
begin
 Sourbran(PrumerX,PrumerY,BSoupere);
 Sourbran(SouX,SouY,BVlastni);
 Cas:=(Cas-1)*18;
 Hriste:=H;
 if Podminky(Hriste,BVlastni,BSoupere,dx,dy,x,y,T) then
 begin
   Nejlepsi:=nil;
   New(Zacatek);
   Rodic:=nil;
   Zacatek^.Krok:=0;
   DelejStrom(Zacatek,Rodic,x,y,dx,Hriste,Bvlastni,BSoupere,0);
   R6Tah:=Najdi(Nejlepsi);
   MazStrom(Zacatek);
 end
 else R6Tah:=T;
end;
end.