Unit F_SYSTEM;
interface
uses f_typy;
procedure Zacatek(var H:PPole;var dx,dy,x,y:integer;var BVlastni,BSoupere:PBrana);
function Lze(H:PPole;dx,Tah:integer;x,y:integer):boolean;
function HracTah(H:PPole;dx:integer;x,y:integer):integer;
procedure Cesta(H:PPole;dx,Tah:integer;var x,y:integer; var Odraz:boolean);
function Je_gol(x,y:integer;BVlastni,BSoupere:PBrana):boolean;
procedure Resume(y,Tah:integer;r:boolean);
procedure Uvolni(bv,bs:PBrana);

implementation
uses crt;
function Moc(m:integer):integer; {mocnina 2 na N - viz nize}
var
 i,Mocnina:integer;
begin
 Mocnina:=1;
 for i:=1 to m do
 Mocnina:=Mocnina*2;
 Moc:=mocnina;
end;
{******************************}
function Lze;
var     {Jestli lze provest pozadovany tah}
 n,Mocnina:integer;
 Obsazen:byte;
 Hriste:^byte;
begin
 if Tah=0 then Lze:=false else
 begin
 Lze:=true;
 Hriste:=H;
 Integer(Hriste):=(y-1)*dx+x; {na vychozi pozici}
 Obsazen:=Hriste^;
 for n:=7 downto 0 do
 begin
  Mocnina:=Moc(n);
  if (Obsazen>=Mocnina)and(Mocnina=Tah) then Lze:=False; {zda se vyskytuji mocniny 2}
  Obsazen:=Obsazen mod Mocnina;
 end;{for}
 end;{if}
end;
{**************************************}
procedure Zacatek;
var
 i:integer;
 Hriste:^byte;
 AV,AS:PBrana;
 VelikostBrany:byte;
begin
 writeln ('Zadej rozmery hriste (X>6, Y>8 - nejlepe licha cisla):');
 repeat
  write   ('X=');
  readln  (dx);
 until dx>6;
 repeat
  write   ('Y=');
  readln  (dy);
 until dy>8;
 if MaxAvail>=dx*dy then GetMem(H,dx*dy+1) {prideleni pameti}
                    else begin
                          write   ('Chyba -1: Nedostatek volne pameti!');
                          readln;
                          exit;
                         end;
 Hriste:=H;
 for i:=0 to dx*dy do
 begin
  Integer(Hriste):=i;
  Hriste^:=0; {naplneni nulama}
  if (i>1)and(i<dx) then Hriste^:=31;
  if (i>(dy-1)*dx+1)and(i<dx*dy) then Hriste^:=241;
  if (i mod dx)=1 then Hriste^:=124;
  if (i mod dx)=0 then Hriste^:=199;
 end; {implementace sten}
 Integer(Hriste):=1;
 Hriste^:=127;
 Integer(Hriste):=dx;
 Hriste^:=223;
 Integer(Hriste):=(dy-1)*dx+1;
 Hriste^:=253;
 Integer(Hriste):=dx*dy;
 Hriste^:=247;
 {implementace rohu}

 x:=(dx div 2)+1;
 y:=(dy div 2)+1;{blize k vlastni brane, pokud nejsou liche rozmery, protoze vlastni zacina}
 {umisteni vychoziho bodu}

 if (dx mod 2=0) then VelikostBrany:=(((dx+3) div 3) div 3)*3
                 else VelikostBrany:=(((dx+1) div 3) div 2)*2;
 New(AV);      New(AS);
 BVlastni:=AV; BSoupere:=AS;
 AV^.predchozi:=nil;
 AS^.predchozi:=nil;
 for i:=1 to VelikostBrany do
 begin
  AV^.x:=((dx-VelikostBrany+1) div 2)+i-1;
  AV^.y:=dy;
  New(AV^.dalsi);
  (AV^.dalsi)^.predchozi:=AV;
  AV:=AV^.dalsi;
  AS^.x:=((dx-VelikostBrany+1) div 2)+i-1;
  AS^.y:=1;
  New(AS^.dalsi);
  (AS^.dalsi)^.predchozi:=AS;
  AS:=AS^.dalsi;
 end;
 AV^.x:=((dx-VelikostBrany+1) div 2)+i;
 AV^.y:=dy;
 AV^.dalsi:=nil;
 AS^.x:=((dx-VelikostBrany+1) div 2)+i;
 AS^.y:=1;
 AS^.dalsi:=nil;
 {vytvoreni bran}
end;
{*************************************}
function HracTah;
var
 Key:char;
 Tah:integer;
 Hriste:^byte;
begin
 Hriste:=H;
 Integer(Hriste):=(y-1)*dx+x;
 if Hriste^=255 then Tah:=-10 else
 repeat              {Chyba -10: Neni mozny zadny dalsi tah.}
  Tah:=0;
  Key:=readkey;
  if Upcase(Key)='Q' then Exit;
  case Key of
   '1':Tah:=32;
   '2':Tah:=64;
   '3':Tah:=128;
   '4':Tah:=16;
   '6':Tah:=1;
   '7':Tah:=8;
   '8':Tah:=4;
   '9':Tah:=2;
  end;
 until Lze(H,dx,Tah,x,y);
 HracTah:=Tah;
end;
{****************************************}
procedure Cesta;
var
 Hriste:^byte;
begin
 Hriste:=H;
 Integer(Hriste):=(y-1)*dx+x;
 Hriste^:=Hriste^+Tah; {pripocteni tahu k vychozimu bodu}
 case Tah of
  1:begin x:=x+1; Tah:=16 end;
  2:begin x:=x+1; y:=y-1; Tah:=32 end;
  4:begin y:=y-1; Tah:=64 end;
  8:begin x:=x-1; y:=y-1; Tah:=128 end;
  16:begin x:=x-1; Tah:=1 end;
  32:begin x:=x-1; y:=y+1; Tah:=2 end;
  64:begin y:=y+1; Tah:=4 end;
  128:begin x:=x+1; y:=y+1; Tah:=8 end;
 end;
 Integer(Hriste):=(y-1)*dx+x;
 Hriste^:=Hriste^+Tah; {pripocteni tahu(protejsiho) k cilovemu bodu}
 Odraz:=false;
 if Hriste^-Tah<>0 then Odraz:=True;
end;
{**************************************}
function Je_gol;
begin
 Je_gol:=false;
 repeat
  if (BVlastni^.x=x)and(BVlastni^.y=y) then Je_gol:=true;
  BVlastni:=BVlastni^.dalsi;
 until BVlastni=nil;
 repeat
  if (BSoupere^.x=x)and(BSoupere^.y=y) then Je_gol:=true;
  BSoupere:=BSoupere^.dalsi;
 until BSoupere=nil;
end;
{*************************************}
procedure Resume;
begin
 Writeln;
 write   ('           Vyhral ');
 if ((Tah=-10)and(not r))or((Tah<>-10)and(y=1)) then write   ('cerveny')
 {r,Tah v pripade zablokovani}                  else write   ('modry');
 writeln ('!!! Gratulujeme.');
 Writeln;
 Writeln ('A nezapomente:');
 Writeln;
 Writeln ('                Slava vitezum, ');
 Writeln ('                cest porazenym.');
 readln;
end;
{*****************************}
procedure Uvolni;
var av,as:PBrana;
begin
 repeat
  av:=bv;
  bv:=bv^.dalsi;
  as:=bs;
  bs:=bs^.dalsi;
  dispose(av);
  dispose(as);
 until bv=nil;
end;
end.