uses crt,typy,R7,grafika,pomocfce;

const cas:longint=5;

type
  THrac='1'..'2';
  kdo_se_trefil=0..2;

var
  Brana1,Brana2:PBrana;
  Hriste:PPole;
  x,y,dx,dy,smer,problem:integer;
  kdo_ma_hrat:THrac;
  error:Boolean;

procedure Nacti_hriste(var Hriste:PPole;var dx,dy,x,y:Integer;var Brana1,Brana2:PBrana);
  var
    f:file;
    VelikostBr,i:integer;
    Brana:PBrana;
  begin
  assign(f,'hriste.dat');reset(f,1);
    blockread(f,dx,2);blockread(f,dy,2);
    getmem(Hriste,dx*dy);
    blockread(f,Hriste^,dx*dy);
    blockread(f,VelikostBr,2);
    new(Brana1);Brana:=Brana1;
    for i:=1 to VelikostBr do
      begin
      blockread(f,brana^.x,4);
      if i<VelikostBr then
        begin
        new(Brana^.dalsi);
        Brana:=Brana^.dalsi;
        end;
      end;
    brana^.dalsi:=Brana1;
    blockread(f,VelikostBr,2);
    new(Brana2);Brana:=Brana2;
    for i:=1 to VelikostBr do
      begin
      blockread(f,brana^.x,4);
      if i<VelikostBr then
        begin
        new(Brana^.dalsi);
        Brana:=Brana^.dalsi;
        end;
      end;
    brana^.dalsi:=Brana2;
  blockread(f,x,2);blockread(f,y,2);
  close(f);
  end;

function kdo_zacina:THrac;
  var klavesa:char;
  begin
  cls;
  Outtextxy(0,0,'Kdo ma zacinat?',cyan);
  Outtextxy(0,24,'1. Hrac',blue);
  Outtextxy(0,36,'2. Pocitac',red);
  repeat
  klavesa:=readkey;
  until klavesa in ['1'..'2'];
  kdo_zacina:=klavesa;
  cls;
  end;

function Gol(x,y:integer;Brana1,Brana2:PBrana):kdo_se_trefil;
  function zasah(br:PBrana):boolean;
    var
      pom:PBrana;
      trefa:Boolean;
    begin
    pom:=br;
    trefa:=false;
    repeat
      if (br^.x=x) and (br^.y=y) then trefa:=true
      else br:=br^.dalsi;
    until (br=pom) or trefa;
    zasah:=trefa;
    end;
  begin
  if zasah(brana1) then gol:=1
  else
    if zasah(brana2) then gol:=2
    else gol:=0;
  end;


function Konec:boolean;
  var smery:integer;
  begin
  konec:=false;
  case Gol(x,y,Brana1,Brana2)of
    1:begin
      outtextxy(0,getmaxy-12,'Konec zapasu, hrac dostal gol!',cyan);
      konec:=true;
      end;
    2:begin
      outtextxy(0,getmaxy-12,'Konec zapasu, pocitac dostal gol!',cyan);
      konec:=true;
      end;
    0:begin
      smery:=najdi_smery(Hriste,dx,dy,x,y);
      if smery=255 then
        begin
        case kdo_ma_hrat of
          '1':Outtextxy(0,getmaxy-12,'Prohral hrac, nema kam pokracovat!!!',cyan);
          '2':Outtextxy(0,getmaxy-12,'Prohral pocitac, nema kam pokracovat!!!',cyan);
          end;
        konec:=true;
        end;
      if smery<0 then
        begin
        konec:=true;
        chyba(smery);
        end;
      end;
    end;
  end;

procedure posun(var x,y:integer;smer:integer);
  begin
  case smer of
    1:inc(x);
    2:begin inc(x);inc(y);end;
    4:inc(y);
    8:begin dec(x);inc(y);end;
    16:dec(x);
    32:begin dec(x);dec(y);end;
    64:dec(y);
    128:begin inc(x);dec(y);end;
    end;
  end;

function Hrac:Integer;
  const tabulka:array ['1'..'9'] of byte=(8,4,2,16,0,1,32,64,128);
  var
    OK:Boolean;
    klavesa:char;
  begin
  OK:=false;
  repeat
    klavesa:=readkey;
    if klavesa in ['1'..'4','6'..'9'] then
      OK:=(tabulka[klavesa] and (najdi_smery(hriste,dx,dy,x,y)))=0;
  until OK;
  hrac:=tabulka[klavesa];
  end;

begin
Nacti_Hriste(Hriste,dx,dy,x,y,Brana1,Brana2);
kdo_ma_hrat:=kdo_zacina;
Zobraz_Hriste(Hriste,dx,dy,x,y,Brana1,Brana2,problem);
if problem<0 then
  begin
  chyba(problem);
  error:=true;
  end
else error:=false;

while not (Konec or error) do
  begin
  case kdo_ma_hrat of
    '1':begin
        Outtextxy(0,getmaxy-12,'Na rade je hrac!!!',blue);
        smer:=Hrac;
        Zobraz_tah(x,y,smer,blue);
        dopln_smery(hriste,dx,dy,x,y,smer);
        posun(x,y,smer);
        if najdi_smery(hriste,dx,dy,x,y)=0 then kdo_ma_hrat:='2';
        smer:=smer div 16 + 255 and (smer*16);
        dopln_smery(hriste,dx,dy,x,y,smer);
        end;
    '2':begin
        Outtextxy(0,getmaxy-12,'Na rade je pocitac!!!',red);
         {smer:=hrac; }
         smer:=R7Tah(Hriste,dx,dy,x,y,Brana2,Brana1,cas);
        if (smer and najdi_smery(hriste,dx,dy,x,y))=0 then
          begin
          Zobraz_tah(x,y,smer,red);
          dopln_smery(hriste,dx,dy,x,y,smer);
          posun(x,y,smer);
          if najdi_smery(hriste,dx,dy,x,y)=0 then kdo_ma_hrat:='1';
          smer:=smer div 16 + 255 and (smer*16);
          dopln_smery(hriste,dx,dy,x,y,smer);
          end;
        end;
    end;
  end;
Freemem(Hriste,dx*dy);
readln;
konec_grafiky;
end.