#include <stdio.h>

#define uchar unsigned char
// jako BYTE
#define ushort unsigned short
// jako WORD
#define ulong unsigned long
// jako DWORD

class BitOutput
// bitovy vystup
{
  public:
    BitOutput(char *name);
    // name - jmeno vystupniho souboru
    ~BitOutput();
    void Write(ushort w, int n);
    // zapise na vystup n bitu z parametru w
  private:
    FILE *_file; // handle souboru
    uchar buf; // vystupni buffer 
    int buflen; // pocet platnych bitu v bufferu
};

class BitInput
// bitovy vstup
{
  public:
    BitInput(char *name);
    // name - jmeno vstupniho souboru
    ~BitInput();
    int Read(ushort &w, int n);
    // ze vstupu precte n bitu a zapise je promenne w
  private:
    FILE *_file; // handle souboru
    uchar buf; // vstupni buffer
    int buflen; // pocet platnych bitu v bufferu
};

