{**************************************************************}
{* GALLERY.PAS Galerie obrazku v HTML                         *}
{* Zpracovali: Frantisek Jandos, Petr Nehez a Frantisek Liska *}
{* 6.12. 1998                           skupina c. 22         *}
{**************************************************************}

uses Crt, Dos;
var
  soubor, pripona : string;

procedure CreateHtml(fname:string; suffix:string); {Vytvareni HTML dokumentu}
var
 files : SearchRec;
 html  : Text;
begin
 Assign(html,fname);
 Rewrite(html);                  {Otevri HTML dokument}
 Writeln(html,'<HTML>');
 Writeln(html,'<BODY>');         {Dva povine radky HTML}  
  FindFirst('*.'+suffix, AnyFile, files); {Najdi prvni soubor v adresari}
  while DosError = 0 do
   begin
    Writeln(Html,'<img src="',files.Name,'" alt="',files.Name,'" hspace="15" vspace="15">'); {Radka definujici: zarad obrazek}
    FindNext(files); {Hldej dalsi soubor}
  end;
 Writeln(html,'</BODY>');
 Writeln(html,'</HTML>');    {Opet dve povine radky}
 Close(html);
end;

begin
 if ParamCount=0 then Writeln('Pouziti: gallery soubor [pripona]') {pokud nebyly zadany parametry}
  else
   begin
    soubor:=ParamStr(1);
     if pos('.',soubor)=0 then soubor:=soubor+'.htm'; {pokud nebyla zadana pripona, prirad ji}
    pripona:=ParamStr(2);
     if pripona='' then pripona:='gif'; {pokud nebyl zadan typ hledanych souboru}
    CreateHtml(soubor,pripona);
 end;
end.