uses crt,dos;

procedure SkryjKurzor; {skryje kurzor na obrazovce}
 var Regs:Registers;
 begin
   with regs do
   begin
     AH:=$01;
     CH:=32;
     CL:=0;
     Intr($10,Regs);
   end;
 end;

procedure VratKurzor;  {zobrazi kurzor na obrazovce}
 var Regs:Registers;
 begin
   with regs do
   begin
     AH:=$01;
     CH:=13;
     CL:=14;
     Intr($10,Regs);
   end;
 end;

var Key:char; {stisknuta klavesa}
    P1,P2,PP1,PP2,X1,X2,Y1,Y2,posun,cykl,rychlost,skore1,skore2:integer;
    {soucasna poloha hrace 1, soucasna poloha hrace 2, minula poloha hrace 1,
    minula poloha hrace 2, X1,Y1-soucasna poloha micku, X2,Y2 - minula poloha
    micku, svisly posun micku, citac opakovani cyklu, rychlost pohybu micku a
    hracu, pocet bodu hrace 1, pocet bodu hrace 2}
    doprava,dolu,jeden:boolean;
    {pohyb micku vodorovne, pohym micku svisle, rezim pro jednoho nebo dva hrace}
    Pn1,Pn2:0..2; {Posun hrace, 0-stop,1-dolu,2-nahoru}

procedure Start;
{nastaveni promennych na pocatecni hodnoty a vykresleni pozadi}
begin
 CYKL:=1;
 rychlost:=15;
 Pn1:=0;
 Pn2:=0;
 SkryjKurzor;
 TextBackGround(7);
 ClrScr;
 Window(2,2,79,24);
 TextBackGround(0);ClrScr;
 TextColor(7);
 for P1:=1 to 23 do {nakresli sit na hristi}
  begin
   gotoxy(39,P1);
   Write('');
  end;
 PP1:=1;PP2:=1;
 P1:=12; P2:=12;
 Window(2,1,80,25);
 TextColor(0);TextBackGround(7);
 gotoxy(3,1); write('Q-nahoru,A-stop,Z-dolu          Esc-konec           O-nahoru,K-stop,M-dolu');
 Window(2,2,80,25);
 gotoxy(35,24); write(skore1:4,':',skore2);
 gotoxy(64,24); write('Team Twenty-Six');
 X1:=39; Y1:=1;
 X2:=39; Y2:=1;
 randomize; {nahodne urceni pohybu pri vypusteni micku}
 doprava:=boolean(Random(2));
 dolu:=boolean(Random(2));
 posun:=1;
 TextBackGround(0);
 TextColor(15);
end;

procedure Krize;
{dokresli krizovou polohu micku a zajisti zvukovy vystup}
begin
       if doprava then Inc(X1) else Dec(X1);
       if dolu then Y1:=Y1+posun else Y1:=Y1-posun;
       if Y1>23 then Y1:=23;
       if Y1<1 then Y1:=1;
      Gotoxy(X2,Y2); if X2=39 then
       begin
        TextCOlor(7);
        Write('');
        TextCOlor(15);
       end else Write(' ');
      Gotoxy(X1,Y1); Write('');
      X2:=X1;
      Y2:=Y1;
      for PP1:=1000 downto 1 do begin Sound(PP1); delay(1) end;
      nosound;

end;

begin
if paramcount<>0 then jeden:=true else jeden:=false; {urceni modu pro dva nebo jednoho hrace}
Start;
skore1:=0;
skore2:=0;
 repeat
   if rychlost<2 then rychlost:=2;
   if PP1<>P1 then {vykresleni hrace nalevo}
    begin
      Gotoxy(1,PP1); Write(' ');
      Gotoxy(1,PP1+1); Write(' ');
      Gotoxy(1,P1); Write('');
      Gotoxy(1,P1+1); Write('');
      PP1:=P1;
    end;
   if PP2<>P2 then {vykresleni hrace napravo}
    begin
      Gotoxy(78,PP2); Write(' ');
      Gotoxy(78,PP2+1); Write(' ');
      Gotoxy(78,P2); Write('');
      Gotoxy(78,P2+1); Write('');
      PP2:=P2;
    end;
   if (X1<>X2)or(Y1<>Y2) then {vykresleni micku}
    begin
      Gotoxy(X2,Y2); if X2=39 then
       begin
        TextCOlor(7);
        Write('');
        TextCOlor(15);
       end else Write(' ');
      Gotoxy(X1,Y1); Write('');
      X2:=X1;
      Y2:=Y1;
    end;
    if Y1>22 then dolu:=false; {odrazeni micku od dna}
    if Y1<2 then  dolu:=true;  {odrazeni micku od stropu}
    if (X1=77) then {vyhodnoceni odrazu micku od hrace napravo}
     begin
      if (P2=Y1)or(P2+1=Y1) then begin sound(1000);delay(1);nosound;
      doprava:=false; Dec(rychlost);
      cykl:=10;
     end
      else
      if (P2-1=Y1)or(P2+2=Y1) then
       begin sound(1000);delay(1);nosound;
          if posun=2 then posun:=1 else posun:=2;
          if (P2+2=Y1) then if not dolu then dolu:=true;
          if (P2-1=Y1) then if dolu then dolu:=false;
          doprava:=false; Dec(rychlost);
          cykl:=10;
       end
      else
       begin  {netrefil se}
        Krize;
        Inc(Skore1);
        Start;
       end;
     end;
    if (X1=2) then  {vyhodnoceni odrazu micku od hrace nalevo}
     begin
      if (P1=Y1)or(P1+1=Y1) then
       begin sound(1000);delay(1);nosound;
             doprava:=true;  Dec(rychlost);
             cykl:=10;
       end
      else
      if (P1-1=Y1)or(P1+2=Y1) then
        begin sound(1000);delay(1);nosound;
          if posun=2 then posun:=1 else posun:=2;
          if (P1+2=Y1) then if not dolu then dolu:=true;
          if (P1-1=Y1) then if dolu then dolu:=false;
          doprava:=true;  Dec(rychlost);
          cykl:=10;
        end
      else
       begin  {netrefil se}
        Krize;
        Inc(Skore2);
        Start;
       end;
     end;
    if (cykl mod 10 =0) then  {posun micku}
     begin
       if doprava then Inc(X1) else Dec(X1);
       if dolu then Y1:=Y1+posun else Y1:=Y1-posun;
       if Y1>23 then Y1:=23;
       if Y1<1 then Y1:=1;
     end;
   if Keypressed then Key:=readkey;
   Key:=UpCase(Key);
   case Key of  {zmena pohybu hracu}
    'Q': Pn1:=2;
    'A': Pn1:=0;
    'Z': Pn1:=1;
    'Y': Pn1:=1;
    'O': Pn2:=2;
    'K': Pn2:=0;
    'M': Pn2:=1;
   end;
   if (cykl mod 2 =0) then {nastaveni pohybu hracu}
   begin
    case Pn1 of
     1: Inc(P1);
     2: Dec(P1);
    end;
    case Pn2 of
     1: Inc(P2);
     2: Dec(P2);
    end;
   end;
   {usmerneni pohybu hracu}
   if jeden then P1:=Y1;
   if P1<1 then P1:=1;
   if P1>22 then P1:=22;
   if P2<1 then P2:=1;
   if P2>22 then P2:=22;
   if Key<>#27 then Key:=#7;
   Cykl:=pred(cykl); {zapocteni prubehu cyklu}
   delay(rychlost*posun); {pozdrzeni pohybu}
   if (skore1=5)or(skore2=5) then  {ukonceni hry}
    begin
     Window(1,1,80,25);
     TextBackGround(0);TextColor(15);
     ClrScr;
     gotoxy(35,24); write(skore1:4,':',skore2);
     Gotoxy(25,12);
     if skore2=5 then write('Vitezem je hrac na prave strane.');
     if skore1=5 then write('Vitezem je hrac na leve strane.');
     Gotoxy(25,13);
     write('mezernik-nova hra,    Esc-konec');
     repeat
      Key:=readKey;
     until (Key=#27)or(key=' ');
     if Key=' 'then
      begin
       skore1:=0;
       skore2:=0;
       start;
      end;
    end;
 until Key=#27;
 {vyklizeni obrazovky}
 VratKurzor;
 Window(1,1,80,25);
 TextCOlor(7); TextBackGround(0);
 ClrScr;
end.