unit m_antsc;

interface

type
  { lin. spoj. seznam }
  t_ant_req_ptr = ^t_ant_req;
  t_ant_req = record
    x, y: integer;
    direction: byte;
    next: t_ant_req_ptr;
  end;

procedure add_req(var _req: t_ant_req_ptr; _x, _y: integer; _dirc: byte);

implementation

procedure add_req(var _req: t_ant_req_ptr; _x, _y: integer; _dirc: byte);
var
  temp_ptr: t_ant_req_ptr;
begin
  new(temp_ptr);
  temp_ptr^.x:=_x;
  temp_ptr^.y:=_y;
  temp_ptr^.direction:=_dirc;
  temp_ptr^.next:=nil;

  if _req<>nil then temp_ptr^.next:=_req;
  _req:=temp_ptr;
end;

procedure delete_reg(var _reg: t_ant_req_ptr);
var
  temp_ptr, dummy_ptr: t_ant_req_ptr;
begin
  temp_ptr:=_reg;
  while (temp_ptr<>nil) do
  begin
    dummy_ptr:=temp_ptr^.next;
    dispose(temp_ptr);
    temp_ptr:=dummy_ptr;
  end;
end;

begin

end.