{ modul pro ovladani casovace }
{ David Andrs }
unit m_timer;

interface

var
  timer_rate: word;                            { aktualni frekvence casovace }

procedure speed_timer(rate: word);
{ nastavi frekvenci casovace na 'rate' }
procedure restore_timer;
{ obnovi rychlost casovace na 'default' }

implementation

procedure speed_timer(rate: word);
var
  divisor: word;
begin
  divisor:=$1234DC div rate;
  port[$43]:=$36;
  port[$40]:=lo(divisor);
  port[$40]:=hi(divisor);
  timer_rate:=rate;
end;

procedure restore_timer;
begin
  port[$43]:=$36;
  port[$40]:=0;
  port[$40]:=0;
end;

begin
  timer_rate:=0;  { default }
end.