unit menu_2; {tato unita se stara o vykresleni menu a polozek a vybere jednu}

interface

type Tprvek=^Tmenu;
     Tmenu = record
           Polozka:string[20];
           dp,pc:byte;{delka polozky a poradove cislo}
           nextp:Tprvek;
           end;
{******************** recepty *****************************************************************}
function MakePrvek(Nazev:string;cislo:byte):Tprvek; {vytvori prvni prvek seznamu}
Procedure freemem(var start:Tprvek); {uvolni seznam z pameti od staru}
procedure addprvek(var kam:Tprvek;Nazev:string;cislo:byte); {prida prvek do seznamu}
Function DoMenu(sx,sy:byte;prvni:Tprvek):byte; {hlavni procedure pro vykresleni a vyber z menu}
{**********************************************************************************************}

implementation
uses crt;
{++++++++++++++++++++++ Soukroma cast +++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function MakePrvek(Nazev:string;cislo:byte):Tprvek; {vytvori prvni prvek v seznamu}
 var pom:Tprvek;

 begin
 new(pom); {novy seznam}
 with pom^ do {kvuli zkraceni vypoctu adresy polozek seznamu}
  begin
   Polozka:=Nazev; {prirazeni jednotlivyhc polozek *******************************************}
   dp:=length(Nazev);
   pc:=cislo;
   nextp:=nil;{*******************************************************************************}
  end;
 MakePrvek:=pom;
 end;

Procedure freemem(var start:Tprvek); {uvolni seznam z pameti od staru}
 var pom:Tprvek;
 begin
  pom:=start; {nastav na zacatek}
  if start^.nextp <> nil then  {pokud neni prazdny tak delej}
     while start^.nextp <> nil do {dokud neni prazdny tak delej}
      begin
       pom:=start^.nextp; {nastav se na dalsi}
       dispose(start); {smaz starou z pameti}
       start:=pom; {prenastav se}
      end;
 end;

procedure addprvek(var kam:Tprvek;Nazev:string;cislo:byte); {pridej prvek do seznamu}
 var pom,pom1:Tprvek;
     a:byte;
 begin
  a:=0;					{to kvuli potrebe prazdneho seznamu}
  if kam=nil then begin			{pokud jeste neni seznam tak}
                   new(kam);		{vytvor seznam}
                   a:=1; 		{nastav flag noveho seznamu}
                   kam^.nextp:=nil;	{dalsi ukazuje na NIL}
                  end;
  pom:=kam;				{ukaze na kam tedy na zacatek seznamu}
  while pom^.nextp <> nil do		{dokud neni na konci tak se presouva ukazatel}
        pom:=pom^.nextp;		{to je to presunuti az na konec seznamu}
  pom1:=MakePrvek(Nazev,cislo);		{tady se vytvori pozadovany zaznam v seznamu}
  if a = 0 then pom^.nextp:=pom1 else kam:=pom1; {a tady se prvek zaradi na spravne misto}
 end;

Function DoMenu(sx,sy:byte;prvni:Tprvek):byte;

 {*************** tato procedure obsahuje nekolik podsluzeb ***********}

  const bpozadi=1;
        bpopredi=14;

  var  de,pc:byte; {max delka prvku a count of polozek}

 procedure zaklad(x,y,sire,pp:byte); {vykresli podklad + hezke ramecky automaticky}
  var i,j:byte;
  begin
   textbackground(0); {trapne inicializovani barev ------------------------------}
   clrscr;
   textbackground(bpozadi);
   textcolor(bpopredi);{---------------------------------------------------------}
   pp:=pp-1;  {vykresleni do smeru Y - misto pro ramecky}
   sire:=sire+1; {to same pro X-vou osu}
   for i:= y to pp+y+2 do                       {stara se o samotne vykresleni plochy}
    begin
    j:=x;
    gotoxy(j,i);
    for j:= x to x+sire+2 do
     begin
      if ((i=y)or(i=pp+y+2))and((j>x)and(j<x+sire+2)) then write(chr(205))  {vykresleni rakdu}
      else
       if ((j=x)or(j=x+sire+2))and((i>y)and(i<pp+y+2))then write(chr(186))  {vykresleni sloupcu}
       else write(' ');
     end;
   end; {podklad bez ramcku v rohu je hotov}
   gotoxy(x,y);write(chr(201));   {trapne zapisovani rohu podkladu +++++++++++++}
   gotoxy(x,y+pp+2);write(chr(200));
   gotoxy(x+sire+2,y);write(chr(187));
   gotoxy(x+sire+2,y+pp+2);write(chr(188));
   textcolor(7); {++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
  end;

 function mdelka(zacatek:tprvek):byte; {stara se o zjisteni nejvetsi delku v seznamu}
  var delka:byte;
      pom:tprvek;

  begin
   delka:=0; {pokud by byl prazdny}
   pom:=zacatek; {na zacatek seznamu se nastav} 
   while pom<>nil do {dokud polozka v seznamu neukazuje na NIL tak delej}
    begin
     if pom^.dp>delka then delka:=pom^.dp; {pokud je nahodou delsi naz mame tak ji zmen}
     pom:=pom^.nextp; {a sup na dalsi prvek}
    end;
   mdelka:=delka; {urceni funkce}
  end;

 function itemsqv(zacatek:tprvek):byte; {zjisteni poctu polozek}
  var pocet:byte;
      pom:tprvek;

  begin
   pocet:=0; {zatim zadna polozka}
   pom:=zacatek; {nastaveni na zacatek seznamu}
   while pom<>nil do  {dokud neni konec seznamu, polozka neukazuje na NIL}
    begin
     inc(pocet);    {zvetsi pocet}
     pom:=pom^.nextp;   {nastaveni na dalsi polozku v seznamu}
    end;
   itemsqv:=pocet;  {prirazeni funkci}
  end;

 procedure item(aktivni:byte); {stara se o vykresleni aktivne vybrane polozky}
  var i:byte;
      pom:tprvek;

  begin
   i:=0; {jedem od zacatku}
   pom:=prvni;  {zaloha}
   while prvni <> nil do            {dokud neni konec seznamu tak delej}
    begin
     if i+1=aktivni then textbackground(0)  {zmena barvy pozadi pro aktivni polozku}
      else textbackground(bpozadi); {pokud ne tak standardni barva podkladu}
     gotoxy(sx+2,(sy+1)+i); {zajisteni presuvu na spravne X a Y}
     writeln(prvni^.polozka); {vypis obsahu polozky}
     prvni:=prvni^.nextp; {presuv na dalsi polozku v seznamu}
     inc(i); {zvetseni indexu polozek}
    end;
    prvni:=pom; {obnoveni zalohy}
  end;

 function pohyb:byte; {zajisti pohyb v menu}

 var a:char;   {klavesa pro pohyb}
    konec:boolean; {pro ukonceni  cyklu}
    items,aktiv,vlb:byte; {pocet polozek, prave aktivni polozka a vybrana polozka}

  function vca(aktiv:byte):byte; {vrati poradove cislo aktivni polozky}
   var i:byte;
       pom:tprvek;

   begin
    i:=1;
    pom:=prvni;
    while i <> aktiv do
     begin
       pom:=pom^.nextp;
       inc(i);
     end;
    i:=pom^.pc;
    vca:=i;
   end;

  begin
   items:=itemsqv(prvni); {pocet polozek v seznamu}
   aktiv:=1; {aktivni je prvni polozka}
   konec:=false; {ne ne jeste neni konec}
   while not konec do   { a doku d nebude tak delej}
   begin
    item(aktiv);  {postara se o vykresleni aktivni polozky barvou jinou nez ostatnich}
    gotoxy(80,25); {presnu se na X,Y}
    a:=readkey; {nacti klavesu}
    case a of
      #0:begin    {pokud kurzory tak ...}
          a:=readkey;
          case a of   {podle druhu kurzoru proved:}
           #72:if aktiv > 1 then dec(aktiv) else aktiv:=items; {posuv dolu + zajisteni preteceni}
           #80:if aktiv < items then inc(aktiv) else aktiv:=1;  {posuv nahoru + zajisteni podteceni}
           #75:aktiv:=1; {posuv na zacatek}
           #77:aktiv:=items; {posuv na posledni polozku}
           end;
         end;
       #13:begin  {jo tak tohle znamena vyber polozky}
            vlb:=vca(aktiv);
{            vlb:=aktiv;} {nastaveni polozky volba : vlb na cislo aktivni polozky}
            konec:=true; {a konec menu}
           end;
    end;
   end;
   pohyb:=vlb; {vysledny pohyb se rovna aktivni polozce}
  end;
{***********************     samotna function ***************************}
 begin
  zaklad(sx,sy,mdelka(prvni),itemsqv(prvni)); {vykresli podklad pro menu i s polozkou}
  DoMenu:=pohyb; {rovnou se provede zjisteni urcujici polozky}
  Textbackground(0); {dale se jan smaze obrazovka}
  textcolor(7);
  clrscr; {******************************************************}
 end;

begin
end.