unit grafika;
{programmed by MoPS}
interface

  uses typy;

  const
    black=0;
    blue=1;
    green=2;
    cyan=3;
    red=4;

  procedure Zobraz_Hriste(Hriste:PPole;dx,dy,x,y:Integer;Brana1,Brana2:PBrana;var problem:integer);
  procedure Zobraz_Tah(x,y,smer:Integer;barva:byte);
  procedure OutTextXY(X,Y:Integer;TextString:string;barva:byte);
  procedure Konec_grafiky;
  function  GetMaxX:integer;
  function  GetMaxY:integer;
  procedure Cls;

implementation

  uses pomocfce,graph;

  const koef=20;
  var Gd,Gm:integer;

  procedure Cls;
    begin
    cleardevice;
    end;

  function GetMaxX:integer;
    begin
    getmaxx:=graph.getmaxx;
    end;

  function GetMaxY:integer;
    begin
    getmaxy:=graph.getmaxy;
    end;

  procedure OutTextXY(X,Y:Integer;TextString:string;barva:byte);
    begin
    setcolor(barva);
    setfillstyle(1,black);
    bar(x,y,getmaxx,y+12);
    graph.OutTextXY(X,Y,TextString);
    end;

  procedure Zobraz_Branu(brana:PBrana;barva:byte;var problem:integer);
    var pom:PBrana;
    begin
    if brana<>nil then
      begin
      setcolor(barva);
      pom:=brana;
      repeat
        setfillstyle(1,barva);
        fillellipse(pom^.x*koef,pom^.y*koef,2,2);
        pom:=pom^.dalsi;
      until (pom=brana) or (pom=nil);
      if pom=nil then problem:=-8;
      end
    else problem:=-6;
    end;

  procedure Zobraz_Hriste;
    var i,j,smer:byte;
    begin
    problem:=0;
    if Hriste<>nil then
      begin
      setfillstyle(1,lightgreen);
      bar(koef,koef,dx*koef,dy*koef);
      for j:=1 to dy do
        for i:=1 to dx do
          begin
          smer:=Najdi_Smery(Hriste,dx,dy,i,j);
          Zobraz_Tah(i,j,smer,black);
          end;
      Zobraz_branu(Brana1,Blue,problem);
      Zobraz_branu(Brana2,Red,problem);
      setcolor(white);
      line(x*koef-koef div 2,y*koef,x*koef+koef div 2,y*koef);
      line(x*koef,y*koef-koef div 2,x*koef,y*koef+koef div 2);
      end
    else problem:=-5;
    end;

  procedure Cara(x1,y1,x2,y2:integer;barva:byte);
    begin
    setcolor(barva);
    setlinestyle(0,0,3);
    line(koef*x1,koef*y1,koef*x2,koef*y2);
    end;

  procedure Zobraz_Tah;
    begin
    if smer>0 then
      begin
      if (smer and 1)<>0 then cara(x,y,x+1,y,barva);
      if (smer and 2)<>0 then cara(x,y,x+1,y+1,barva);
      if (smer and 4)<>0 then cara(x,y,x,y+1,barva);
      if (smer and 8)<>0 then cara(x,y,x-1,y+1,barva);
      if (smer and 16)<>0 then cara(x,y,x-1,y,barva);
      if (smer and 32)<>0 then cara(x,y,x-1,y-1,barva);
      if (smer and 64)<>0 then cara(x,y,x,y-1,barva);
      if (smer and 128)<>0 then cara(x,y,x+1,y-1,barva);
      end;
    end;

  procedure Konec_grafiky;
    begin
    Closegraph;
    end;

begin
Gd:=detect;
initgraph(Gd,Gm,'grafika');
if graphresult<>GrOK then
  begin
  write('Nekdo mi ukradl pastelky!!!');
  halt;
  end
else
  begin
  Outtextxy(0,0,'Graficky modul: OK',cyan);
  end;
end.