unit R7;

interface
  uses typy;

  function R7Tah(Hriste:PPole;dx,dy,x,y:Integer;BVlastni,BSoupere:PBrana;Cas:Longint):Integer;

implementation
   uses crt,pomocfce;
   type
        interval=1..8;
        pole8 = array[1..8] of boolean;

        THraci_Plocha=array[0..65519]of byte;
        PHraci_Plocha=^THraci_Plocha;

  procedure prirad_smery(vs:integer;var psmeru:pole8);
            var konec:boolean;
                i:interval;
                ps:integer;
       begin
          for i:=1 to 8 do psmeru[i]:=true;
          ps:=128;
          i:=8;
          konec:=false;
          repeat

              if vs >= ps then
                        begin
                          psmeru[i]:=false;
                          if vs = ps then konec := true
                           else vs:= vs-ps;
                        end;
              ps:=ps div 2;
              i:=i-1;
              if ps=0 then konec:= true;

         until konec;
       end;

  function pri_vzdalenost(pombrana:pbrana; ax,ay:integer):real;
       begin
         with pombrana^ do
          begin
           pri_vzdalenost:=sqrt(sqr(ax-x)+sqr(ay-y));
          end;
       end;

 function pri_bonus(bsoupere:pbrana; x,y:integer):real;
       var aktualni, pristi : real;

   begin
    repeat
      aktualni:=pri_vzdalenost(bsoupere,x,y);
      if bsoupere <> nil then
      bsoupere:=bsoupere^.dalsi;
      if bsoupere <> nil then
      pristi:=pri_vzdalenost(bsoupere,x,y);
    until (aktualni<pristi) or (bsoupere=nil);
    pri_bonus:=1/(aktualni+1);
   end;

  function test_skoku(hriste:ppole;dx,dy,x,y:integer):boolean;
       var vs:integer;
            begin
              vs:=najdi_smery(hriste,dx,dy,x,y);
              test_skoku:=false;
              if (vs<>0)and(vs<>1)and(vs<>2)and(vs<>4)and(vs<>8)
               and(vs<>16)and(vs<>32)and(vs<>64)and(vs<>128)and(vs<>255)
              then test_skoku:=true;
            end;

  procedure ztah(i:interval; x,y:integer; var pomx,pomy:integer);
         begin
          case i of
          1:begin
             pomx:=x+1;
             pomy:=y;
            end;
          2:begin
             pomx:=x+1;
             pomy:=y+1;
            end;
          3:begin
             pomx:=x;
             pomy:=y+1;
            end;
          4:begin
             pomx:=x-1;
             pomy:=y+1;
            end;
          5:begin
             pomx:=x-1;
             pomy:=y;
            end;
          6:begin
             pomx:=x-1;
             pomy:=y-1;
            end;
          7:begin
             pomx:=x;
             pomy:=y-1;
            end;
          8:begin
             pomx:=x+1;
             pomy:=y-1;
            end;
       end;
   end;

 function pri_tah(is:interval):integer;
  begin
   case is of
    1:pri_tah:=1;
    2:pri_tah:=2;
    3:pri_tah:=4;
    4:pri_tah:=8;
    5:pri_tah:=16;
    6:pri_tah:=32;
    7:pri_tah:=64;
    8:pri_tah:=128;
   end;
 end;


function maxbonus( phriste:ppole;bsoupere:pbrana;dx,dy,x,y:integer):real;

     var pomx,pomy,vs:integer;
         psmeru:pole8;
         i:interval;
         pbonus:real;

    begin
     pbonus:=pri_bonus(bsoupere,x,y);
     vs:=najdi_smery(phriste,dx,dy,x,y);
     if vs =255 then pbonus:=(-pbonus)
     else
      if test_skoku(phriste,dx,dy,x,y)then
        begin
          prirad_smery(vs,psmeru);
          for i:=1 to 8 do
          if psmeru[i] then
           begin
            ztah(i,x,y,pomx,pomy);
            if test_skoku(phriste,dx,dy,pomx,pomy)then
             begin
              dopln_smery(phriste,dx,dy,x,y,pri_tah(i));
              if (pbonus<maxbonus(phriste,bsoupere,dx,dy,pomx,pomy))
              then
               pbonus:=maxbonus(phriste,bsoupere,dx,dy,pomx,pomy)
             end
             else if pbonus<pri_bonus(bsoupere,pomx,pomy)
              then pbonus:=pri_bonus(bsoupere,pomx,pomy)
           end;
         end;
      maxbonus:=pbonus;
   end;



  function R7Tah;
    var phriste:ppole;
        is,i:interval;
        pomx,pomy,vs:integer;
        psmeru:pole8;
        hrel,prel,pbonus:real;

    begin
     getmem(phriste,dx*dy);
     PHraci_Plocha(phriste)^:=PHraci_Plocha(hriste)^;
     hrel:=dy;
     pbonus:=(-1);
     vs:= najdi_smery(phriste,dx,dy,x,y);
     prirad_smery(vs,psmeru);
     for i:=1 to 8 do
      if psmeru[i] then
      begin
        ztah(i,x,y,pomx,pomy);
        if test_skoku(phriste,dx,dy,pomx,pomy)then
         dopln_smery(phriste,dx,dy,x,y,pri_tah(i));
        prel:=maxbonus(phriste,bsoupere,dx,dy,pomx,pomy);
        if (pbonus<prel)or((pbonus=prel)and(abs(dy/2-pomy)<hrel))
        then
         begin
          pbonus:=prel;
          hrel:=abs(dy/2-pomy);
          is:=i;
         end;

     end;
   freemem(phriste,dx*dy);
   R7Tah:=pri_tah(is);
 end;

end.